﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using System.Windows.Media;
using Styx;
using Styx.Helpers;
using Styx.Common;
using Styx.CommonBot.POI;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;


namespace FeralKitty
{
    public partial class Classname : CombatRoutine
    {
        public string HavePotionBuff = "";
        public string HaveFlaskBuff = "";
        public string HaveHealPotions = "";
        public string HaveLifeSpirit = "";
        public string HaveHealthStone = "";

        public bool FlaskBuff()
        {
            if (Me.HasAura("Flask of the Warm Sun")) { return true; }
            if (Me.HasAura("Flask of Winter's Bite")) { return true; }
            if (Me.HasAura("Flask of the Earth")) { return true; }
            if (Me.HasAura("Flask of Spring Blossoms")) { return true; }
            if (Me.HasAura("Flask of Falling Leaves")) { return true; }
            if (Me.HasAura("Flask of the Winds")) { return true; }
            if (Me.HasAura("Flask of Titanic Strenght")) { return true; }
            if (Me.HasAura("Flask of the Draconic Mind")) { return true; }
            if (Me.HasAura("Flask of Flowing Water")) { return true; }
            if (Me.HasAura("Flask of Steelskin")) { return true; }
            if (Me.HasAura("Flask of Endless Rage")) { return true; }
            if (Me.HasAura("Flask of Pure Mojo")) { return true; }
            if (Me.HasAura("Flask of Stoneblood")) { return true; }
            if (Me.HasAura("Flask of the Frost Wyrm")) { return true; }
            if (Me.HasAura("Flask of Toughness")) { return true; }
            if (Me.HasAura("Flask of Binding Light")) { return true; }
            return false;
        }

        #region BagItems
        public bool AlchemistFlask()
        {
            if (FeralKittySettings.AllPrefs.Malchemyflask == 1)
            {

                if (!Me.HasAura("Enhanced Agility") && !FlaskBuff() && !Me.Mounted)
                {
                    foreach (WoWItem item in Me.BagItems)
                    {
                        if (item != null)
                        {
                            if (item.Name == "Alchemist's Flask")
                            {
                                Lua.DoString("RunMacroText(\"/use " + item.Name + "\")");
                                Logging.Write(Colors.LightBlue, "Using Alchemist's Flask");
                                break;
                            }
                        }
                    }
                }
            }
            return false;
        }
        public void HealthStone()
        {
            if (Me.Combat
                && FeralKittySettings.AllPrefs.PHealthStone == 1
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.PHealthStoneHealth)
            {
                WoWItem hstone = Me.BagItems.FirstOrDefault(h => h.Entry == 5512);
                if (hstone == null
                    && HaveHealthStone != "no")
                {
                    Logging.Write(Colors.BlanchedAlmond, "I have no Healthstone");
                    HaveHealthStone = "no";
                }
                if (hstone != null && hstone.CooldownTimeLeft.TotalMilliseconds <= 0)
                {
                    hstone.Use();
                    Logging.Write(Colors.BlanchedAlmond, "Using Healthstone");
                    HaveHealthStone = "yes";
                }
                return;
            }
        }
        public void LifeSpirit()
        {
            if (Me.Combat
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.PLifeSpiritHealth
                && FeralKittySettings.AllPrefs.PLifeSpirit == 1)
            {
                WoWItem lspirit = Me.BagItems.FirstOrDefault(h => h.Entry == 89640);
                if (lspirit == null
                    && HaveLifeSpirit != "no")
                {
                    Logging.Write(Colors.BlanchedAlmond, "I have no Life Spirit");
                    HaveLifeSpirit = "no";
                }
                if (lspirit != null && lspirit.CooldownTimeLeft.TotalMilliseconds <= 0)
                {
                    lspirit.Use();
                    Logging.Write(Colors.BlanchedAlmond, "Using Life Spirit");
                    HaveLifeSpirit = "Yes";
                }
                return;
            }
        }
        public void myFlask()
        {
            if(Me.Specialization == WoWSpec.DruidGuardian)
            {
                if (FeralKittySettings.AllPrefs.Earthflask != 0)
                {
                    bool usingFlask = false;
                    if (FeralKittySettings.AllPrefs.Earthflask == 4)
                    {
                        usingFlask = true;
                    }
                    if (Me.GroupInfo.IsInRaid
                        && FeralKittySettings.AllPrefs.Earthflask == 1)
                    {
                        usingFlask = true;
                    }
                    if (Me.IsInInstance
                        && FeralKittySettings.AllPrefs.Earthflask == 2)
                    {
                        usingFlask = true;
                    }
                    if (Me.GroupInfo.IsInParty
                        && FeralKittySettings.AllPrefs.Earthflask == 3)
                    {
                        usingFlask = true;
                    }
                    if (Me.Combat
                        && usingFlask
                        && !FlaskBuff())
                    {
                        WoWItem flask = Me.BagItems.FirstOrDefault(h => h.Name == "Flask of the Earth");
                        if (flask == null
                            && HaveFlaskBuff != "no")
                        {
                            Logging.Write(Colors.BlanchedAlmond, "I have no Earth Flask");
                            HaveFlaskBuff = "no";
                        }
                        if (flask != null && flask.CooldownTimeLeft.TotalMilliseconds <= 0)
                        {
                            flask.Use();
                            Logging.Write(Colors.BlanchedAlmond, "Using Earth Flask");
                            HaveFlaskBuff = "yes";
                        }
                    }
                    return;
                }
            }
            if(Me.Specialization == WoWSpec.DruidFeral) {
                if (FeralKittySettings.AllPrefs.Magilityflask != 0)
                {
                    bool usingFlask = false;
                    if (FeralKittySettings.AllPrefs.Magilityflask == 4)
                    {
                        usingFlask = true;
                    }
                    if (Me.GroupInfo.IsInRaid
                        && FeralKittySettings.AllPrefs.Magilityflask == 1)
                    {
                        usingFlask = true;
                    }
                    if (Me.IsInInstance
                        && FeralKittySettings.AllPrefs.Magilityflask == 2)
                    {
                        usingFlask = true;
                    }
                    if (Me.GroupInfo.IsInParty
                        && FeralKittySettings.AllPrefs.Magilityflask == 3)
                    {
                        usingFlask = true;
                    }
                    if (Me.Combat
                        && usingFlask
                        && !FlaskBuff())
                    {
                        WoWItem flask = Me.BagItems.FirstOrDefault(h => h.Entry == 76084);
                        if (flask == null
                            && HaveFlaskBuff != "no")
                        {
                            Logging.Write(Colors.BlanchedAlmond, "I have no Agility Flask");
                            HaveFlaskBuff = "no";
                        }
                        if (flask != null && flask.CooldownTimeLeft.TotalMilliseconds <= 0)
                        {
                            flask.Use();
                            Logging.Write(Colors.BlanchedAlmond, "Using Agility Flask");
                            HaveFlaskBuff = "yes";
                        }
                    }
                    return;
                }
            }
        }
        public void myPotion()
        {
            bool usingPotion = false;

            if (Me.Specialization == WoWSpec.DruidGuardian)
            {
                if (FeralKittySettings.AllPrefs.virmenBear == 4)
                {
                    usingPotion = true;
                }
                if (Me.GroupInfo.IsInRaid
                    && FeralKittySettings.AllPrefs.virmenBear == 1)
                {
                    usingPotion = true;
                }
                if (Me.IsInInstance
                    && FeralKittySettings.AllPrefs.virmenBear == 2)
                {
                    usingPotion = true;
                }
                if (Me.GroupInfo.IsInParty
                    && FeralKittySettings.AllPrefs.virmenBear == 3)
                {
                    usingPotion = true;
                }
                if (Me.CurrentTarget != null
                    && Me.Combat
                    && FeralKittySettings.AllPrefs.virmenBear != 0)
                {
                    WoWItem potion = Me.BagItems.FirstOrDefault(h => h.Entry == 76089);
                    if (usingPotion)
                    {
                        if (potion == null
                            && HavePotionBuff != "no")
                        {
                            Logging.Write(Colors.BlanchedAlmond, "I have no Agility Potion");
                            HavePotionBuff = "no";
                        }
                        if (potion != null && potion.CooldownTimeLeft.TotalMilliseconds <= 0)
                        {
                            potion.Use();
                            Logging.Write(Colors.BlanchedAlmond, "Using Agility Potion");
                            HavePotionBuff = "yes";
                        }
                    }
                    return;
                }
            }

            if (Me.Specialization == WoWSpec.DruidFeral)
            {
                if (FeralKittySettings.AllPrefs.Mvirmenpotion == 4)
                {
                    usingPotion = true;
                }
                if (Me.GroupInfo.IsInRaid
                    && FeralKittySettings.AllPrefs.Mvirmenpotion == 1)
                {
                    usingPotion = true;
                }
                if (Me.IsInInstance
                    && FeralKittySettings.AllPrefs.Mvirmenpotion == 2)
                {
                    usingPotion = true;
                }
                if (Me.GroupInfo.IsInParty
                    && FeralKittySettings.AllPrefs.Mvirmenpotion == 3)
                {
                    usingPotion = true;
                }
                if (Me.CurrentTarget != null
                    && Me.Combat
                    && FeralKittySettings.AllPrefs.Mvirmenpotion != 0)
                {
                    WoWItem potion = Me.BagItems.FirstOrDefault(h => h.Entry == 76089);
                    if (usingPotion)
                    {
                        if (potion == null
                            && HavePotionBuff != "no")
                        {
                            Logging.Write(Colors.BlanchedAlmond, "I have no Agility Potion");
                            HavePotionBuff = "no";
                        }
                        if (potion != null && potion.CooldownTimeLeft.TotalMilliseconds <= 0)
                        {
                            potion.Use();
                            Logging.Write(Colors.BlanchedAlmond, "Using Agility Potion");
                            HavePotionBuff = "yes";
                        }
                    }
                    return;
                }
            }
        }
        public void myHealthPotion()
        {
            if (Me.CurrentTarget != null
                && Me.Combat
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.PHealthPotionHealth
                && FeralKittySettings.AllPrefs.PHealthPotion == 1)
            {
                WoWItem potion = HealDrink();

                foreach (WoWItem item in Me.BagItems)
                {
                    if (item == potion && item.CooldownTimeLeft.TotalMilliseconds <= 0)
                    {
                        item.Use();
                        Logging.Write(Colors.BlanchedAlmond, "Using " + item.Name);
                        HaveHealPotions = "yes";
                    }
                }
                if (HaveHealPotions != "yes")
                {
                    if (HaveHealPotions != "no")
                    {
                        Logging.Write(Colors.BlanchedAlmond, "I have no healing potions");
                        HaveHealPotions = "no";
                    }
                }
                return;
            }
        }
        public WoWItem potionToUse()
        {
            List<WoWItem> Items = ObjectManager.GetObjectsOfType<WoWItem>(false);
            foreach (WoWItem Item in Items)
            {
                switch (Item.Entry)
                {
                    case 76089: return Item; // Virmen Potion
                    case 58145: return Item; // Potion of Tol'Vir
                }
            }
            return null;
        }
        public WoWItem HealDrink()
        {
            List<WoWItem> Items = ObjectManager.GetObjectsOfType<WoWItem>(false);
            foreach (WoWItem Item in Items)
            {
                switch (Item.Entry)
                {
                    case 76097: return Item; // Master Healing Potion
                    case 80040: return Item; //Endless Master Healing Potion
                    case 63144: return Item; //Baradin's Wardens Healing Potion
                    case 64994: return Item; //Hellscream's Reach Healing Potion
                    case 57193: return Item; //Mighty Rejuvenation Potion
                    case 57191: return Item; //Mythical Healing Potion
                    case 63300: return Item; //Rogue's Draught
                    case 67145: return Item; //Draught of War
                    case 33447: return Item; //Runic Healing Potion
                    case 40077: return Item; //Crazy Alchemist's Potion
                    case 40081: return Item; //Potion of Nightmares
                    case 40087: return Item; //Powerful Rejuvenation Potion
                    case 41166: return Item; //Runic Healing Injector
                    case 43569: return Item; //Endless Healing Potion
                    case 22850: return Item; //Super Rejuvenation Potion
                    case 34440: return Item; //Mad Alchemist's Potion
                    case 39671: return Item; //Resurgent Healing Potion
                    case 31838: return Item; //Major Combat Healing Potion
                    case 31839: return Item; //Major Combat Healing Potion
                    case 31852: return Item; //Major Combat Healing Potion
                    case 31853: return Item; //Major Combat Healing Potion
                    case 32784: return Item; //Red Ogre Brew
                    case 32910: return Item; //Red Ogre Brew Special
                    case 31676: return Item; //Fel Regeneration Potion
                    case 23822: return Item; //Healing Potion Injector
                    case 33092: return Item; //Healing Potion Injector
                    case 22829: return Item; //Super Healing Potion
                    case 32763: return Item; //Rulkster's Secret Sauce
                    case 32904: return Item; //Cenarion Healing Salve
                    case 32905: return Item; //Bottled Nethergon Vapor
                    case 32947: return Item; //Auchenai Healing Potion
                    case 39327: return Item; //Noth's Special Brew
                    case 43531: return Item; //Argent Healing Potion
                    case 18253: return Item; //Major Rejuvenation Potion
                    case 28100: return Item; //Volatile Healing Potion
                    case 33934: return Item; //Crystal Healing Potion
                    case 13446: return Item; //Major Healing Potion
                    case 17384: return Item; //Major Healing Draught
                    case 3928: return Item; //Superior Healing Potion
                    case 9144: return Item; //Wildvine Potion
                    case 12190: return Item; //Dreamless Sleep Potion
                    case 17349: return Item; //Superior Healing Draught
                    case 18839: return Item; //Combat Healing Potion
                    case 1710: return Item; //Greater Healing Potion
                    case 929: return Item; //Healing Potion
                    case 4596: return Item; //Discolored Healing Potion
                    case 858: return Item; //Lesser Healing Potion
                    case 118: return Item; //Minor Healing Potion
                }
            }
            return null;
        }
        #endregion BagItems
    }
}


