﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using System.Windows.Media;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Styx;
using Styx.Helpers;
using Styx.Common;
using Styx.CommonBot.POI;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Action = Styx.TreeSharp.Action;

namespace FeralKitty
{
    public partial class Classname : CombatRoutine
    {

        public override sealed string Name { get { return "Feral + Guardian Druid by Pasterke"; } }

        public override WoWClass Class { get { return WoWClass.Druid; } }

        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private void slog(string format, params object[] args) //use for slogging
        {
            Logging.Write(Colors.Yellow, format, args);
        }

        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            Form1 ConfigForm = new Form1();
            ConfigForm.ShowDialog();
        }

        public override void Initialize()
        {
            Updater.CheckForUpdate();
            Lua.Events.AttachEvent("MODIFIER_STATE_CHANGED", HandleModifierStateChanged);
        }

        public static Stopwatch fightTimer = new Stopwatch();

        public bool RemoveDeadTargets = true;

        public bool SwitchToBearForm = false;

        public override void Pulse()
        {
            try
            {
                if (fightTimer.IsRunning
                    && fightTimer.Elapsed.Seconds >= 30)
                {
                    Blacklist.Add(Me.CurrentTarget, BlacklistFlags.All, new TimeSpan(0, 3, 0));
                    fightTimer.Reset();
                    LogMsg("Take too much time to attack, blacklisting current target", 1);
                    return;
                }
                if (Me.Combat
                    && Me.Specialization == WoWSpec.DruidFeral
                    && !SwitchToBearForm
                    && FeralKittySettings.AllPrefs.ChooseForm != 0)
                {
                    switch (FeralKittySettings.AllPrefs.ChooseForm)
                    {
                        case 1 :
                            if (Me.Shapeshift != ShapeshiftForm.Cat)
                            {
                                CastBuff("Cat Form", 2);
                            }
                            break;
                        case 2 :
                            if (Me.Shapeshift != ShapeshiftForm.Bear)
                            {
                                CastBuff("Bear Form", 2);
                            }
                            break;
                    }
                    return;
                }
                if (Me.Combat
                    && Me.Specialization == WoWSpec.DruidGuardian
                    && Me.Shapeshift != ShapeshiftForm.Bear)
                {
                    CastBuff("Bear Form", 2);
                }
                if (Me.Combat && Me.CurrentTarget.IsFriendly)
                {
                    Me.ClearTarget();
                    LogMsg("Friendly Target removed because I'm in Combat (" + Me.CurrentTarget.Name + ")", 1);
                    return;
                }
                if (!Me.CurrentTarget.IsPlayer && Me.CurrentTarget.IsFriendly)
                {
                    return;
                }
                if (Me.Combat && RemoveDeadTargets && Me.CurrentTarget.IsDead)
                {
                    Me.ClearTarget();
                    LogMsg("Dead Target removed (" + Me.CurrentTarget.Name + ")", 1);
                    return;
                }
            }
            catch { }
        }

        #region CC_Begin


        public override bool NeedRest
        {
            get
            {
                if (UseSpells)
                {
                    if (Me.HealthPercent >= 55
                        && Me.HealthPercent <= 75
                        && !Me.Mounted)
                    {
                        return true;
                    }
                    if (Me.HealthPercent < 55
                        && Me.HealthPercent > 35
                        && !Me.Mounted)
                    {
                        return true;
                    }
                    if (Me.HealthPercent < 35
                        && !Me.Mounted)
                    {
                        return true;
                    }
                }
                return false;
            }
        }

        public override void Rest()
        {
            if (UseSpells)
            {
                if (!Me.HasAura("Food")
                    && !Me.HasAura("Drink")
                    && !Me.HasAura("First Aid")
                    && Me.HealthPercent <= FeralKittySettings.AllPrefs.RejuvenationOOC
                    && Me.HealthPercent >= FeralKittySettings.AllPrefs.HealingTouchOOC
                    && !Me.HasAura(Rejuvenation)
                    && !Me.Mounted)
                {
                    CastBuff(Rejuvenation, 2);
                }
                if (!Me.HasAura("Food")
                    && !Me.HasAura("Drink")
                    && !Me.HasAura("First Aid")
                    && Me.HealthPercent < FeralKittySettings.AllPrefs.HealingTouchOOC
                    && Me.HealthPercent > FeralKittySettings.AllPrefs.EatDrinkOOC
                    && !Me.Mounted)
                {
                    CastBuff(HealingTouch, 2);
                }
                if (!Me.HasAura("First Aid")
                    && Me.HealthPercent < FeralKittySettings.AllPrefs.EatDrinkOOC
                    && !Me.Mounted)
                {
                    Styx.CommonBot.Rest.Feed();
                }
            }
        }

        #endregion

        #region Pull

        public override void Pull()
        {
            if (gotTarget
                && Me.Specialization == WoWSpec.DruidFeral)
            {
                CatPull();
            }
            if (gotTarget
                && Me.Specialization == WoWSpec.DruidGuardian)
            {
                BearPull();
            }
            
        }


        #endregion

        #region Pull Buffs

        public override bool NeedPullBuffs { get { return false; } }

        public override void PullBuff() { }

        #endregion

        #region Pre Combat Buffs

        public override bool NeedPreCombatBuffs
        {
            get
            {
                if (UseSpells)
                {
                    if (SpellManager.HasSpell(MotW)
                        && !Me.HasAura(MotW)
                        && !Me.HasAura("Blessing of Kings")
                        && !Me.HasAura("Legacy of the Emperor")
                        && !Me.HasAura("Embrace of the Shale Spider")
                        && !Me.Mounted)
                    {
                        CastBuff(MotW, 2);
                    }
                }
                if (!Me.Combat
                    && !Me.HasAura("Prowl")
                    && Me.IsSwimming
                    && Me.Shapeshift != ShapeshiftForm.Aqua)
                {
                    CastBuff("Aquatic Form", 2);
                }
                return false;
            }
        }

        public override void PreCombatBuff()
        {

        }

        #endregion

        #region Combat Buffs

        public override bool NeedCombatBuffs
        {
            get
            {

                return false;
            }
        }

        public override void CombatBuff()
        {

        }

        #endregion

        #region Heal

        public override bool NeedHeal
        {
            get
            {

                return false;
            }
        }

        public override void Heal()
        {

        }

        #endregion

        #region Falling

        public void HandleFalling() { }

        #endregion



        #region Combat

        public override void Combat()
        {
            if (Paused)
            {
                return;
            }
            //combatbuffs
            if (SpellManager.HasSpell(MotW)
                        && !Me.HasAura(MotW)
                        && !Me.HasAura("Blessing of Kings")
                        && !Me.HasAura("Legacy of the Emperor")
                        && !Me.HasAura("Embrace of the Shale Spider")
                        && !Me.Mounted)
            {
                CastBuff(MotW, 2);
            }
            if (SpellManager.HasSpell(Barskin)
                && GetSpellCooldown(Barskin).TotalSeconds <= 0
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.Barskin)
            {
                CastSpell(Barskin, 2);
            }
            if (gotTarget
                && SpellManager.HasSpell(SurvivalInstincts)
                && GetSpellCooldown(SurvivalInstincts).TotalSeconds <= 0
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.SurvivalInstincts)
            {
                CastSpell(SurvivalInstincts, 2);
            }
            if (gotTarget
                && SpellManager.HasSpell(FrenziedRegeneration)
                && Me.Shapeshift == ShapeshiftForm.Bear
                && GetSpellCooldown(FrenziedRegeneration).TotalSeconds <= 0
                && !Me.HasAura(FrenziedRegeneration)
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.FrenziedRegeneration
                && Me.FocusPercent >= 60)
            {
                CastSpell(FrenziedRegeneration, 2);
            }
            if (SpellManager.HasSpell(MightOfUrsoc)
                && GetSpellCooldown(MightOfUrsoc).TotalSeconds <= 0
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.MightOfUrsoc)
            {
                CastSpell(MightOfUrsoc, 2);
            }

            myPotion();
            myFlask();

            UseMyTrinketsGloves();
            //end combatbuffs

            //healing
            if (Me.CurrentTarget != null
                    && SpellManager.HasSpell(HealingTouch)
                    && Me.HasAura(69369)
                    && MyAuraTimeLeft(69369, Me) > 2
                    && Me.HealthPercent <= FeralKittySettings.AllPrefs.HealingTouch
                    && LastSpell != HealingTouch)
            {
                if (SpellManager.CanCast(HealingTouch))
                {
                    SpellManager.Cast(HealingTouch);
                    LogMsg(HealingTouch, 5);
                }
            }
            if (Me.CurrentTarget != null
            && SpellManager.HasSpell(CenarionWard)
            && GetSpellCooldown(CenarionWard).TotalSeconds <= 0
            && Me.HealthPercent <= FeralKittySettings.AllPrefs.CenarionWard
            && LastSpell != CenarionWard)
            {
                CastSpell(CenarionWard, 5);
            }

            myHealthPotion();
            HealthStone();
            LifeSpirit();
            //end healing

            //symbiosis
            if (Me.CurrentTarget != null
                && SpellManager.HasSpell(110700)
                && !spellOnCooldown(110700)
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.DivineShield
                && DivineShield)
            {
                if (SpellManager.CanCast(110700))
                {
                    SpellManager.Cast(110700);
                    LogMsg("Divine Shield", 2);
                }
            }
            if (Me.CurrentTarget != null
                && SpellManager.HasSpell(110715)
                && !spellOnCooldown(110715)
                && Me.HealthPercent <= FeralKittySettings.AllPrefs.Dispersion
                && Dispersion)
            {
                if (SpellManager.CanCast(110715))
                {
                    SpellManager.Cast(110715);
                    LogMsg("Dispersion", 2);
                }
            }
            //end symbiosis

            if (Me.CurrentTarget != null
                && !FeralKittySettings.AllPrefs.DisableMovement)
            {
                MoveInRange(3.5f);
            }
            if (Me.CurrentTarget != null
                && !FeralKittySettings.AllPrefs.DisableFacing)
            {
                Me.CurrentTarget.Face();
            }
            CatRotation();
        }
        #endregion

        #region Rotations
        public void CatRotation()
        {
            if (UseSpells)
            {
                 
                if(UseForm == "Cat" && Me.Shapeshift != ShapeshiftForm.Cat
                    && Me.Specialization == WoWSpec.DruidFeral)
                {
                    if (SpellManager.CanCast("Cat Form"))
                    {
                        SpellManager.Cast("Cat Form");
                        LogMsg("Cat Form", 2);
                    }
                }
                if (UseForm == "Bear" && Me.Shapeshift != ShapeshiftForm.Bear)
                {
                    if (SpellManager.CanCast("Bear Form"))
                    {
                        SpellManager.Cast("Bear Form");
                        LogMsg("Bear Form", 2);
                    }
                }
                if (Me.Specialization == WoWSpec.DruidFeral
                    && Me.Shapeshift == ShapeshiftForm.Cat)
                {
                    if (addCount > 1
                        && !IsBoss)
                    {
                        if (savageRoar)
                        {
                            SpellManager.Cast(127538);
                            LogMsg(SavageRoar, 2);
                            return;
                        }
                        if (healingtouch
                        && LastSpell != HealingTouch)
                        {
                            SpellManager.Cast(HealingTouch);
                            LogMsg(HealingTouch + " to proc Dream of Cenarius", 1);
                            LastSpell = HealingTouch;
                        }
                        if (thrash
                            && LastSpell != Thrash
                            && LastSpell != Thrash + " Aoe")
                        {
                            SpellManager.Cast(106830);
                            LogMsg(Thrash + " with Clearcasting", 9);
                            LastSpell = Thrash;
                            return;
                        }
                        if (thrashaoe
                            && LastSpell != Thrash + " Aoe"
                            && LastSpell != Thrash)
                        {
                            SpellManager.Cast(106830);
                            LogMsg(Thrash + " Aoe", 6);
                            return;
                        }
                        if (swipe)
                        {
                            SpellManager.Cast(Swipe);
                            LogMsg(Swipe + " Aoe", 6);
                        }
                        if (savageRoarcp)
                        {
                            SpellManager.Cast(127538);
                            LogMsg(SavageRoar, 0);
                            return;
                        }
                    }
                    if (mightybash && LastSpell != SkullBash)
                    {
                        SpellManager.Cast(MightyBash);
                        LogMsg(MightyBash, 6);
                    }
                    if (skullbash && LastSpell != MightyBash)
                    {
                        SpellManager.Cast(SkullBash);
                        LogMsg(SkullBash, 6);
                    }
                    if (faerieSwarm)
                    {
                        SpellManager.Cast(FaerieSwarm);
                        LogMsg(FaerieSwarm, 3);
                        return;
                    }
                    if (faerieFire)
                    {
                        SpellManager.Cast(FaerieFire);
                        LogMsg(FaerieFire, 3);
                        return;
                    }
                    if (savageRoar)
                    {
                        SpellManager.Cast(127538);
                        LogMsg(SavageRoar, 2);
                        return;
                    }
                    if (healingtouch
                        && LastSpell != HealingTouch)
                    {
                        SpellManager.Cast("Healing Touch");
                        LogMsg(HealingTouch + " to proc Dream of Cenarius", 1);
                        LastSpell = HealingTouch;
                    }
                    if (thrash
                        && LastSpell != Thrash)
                    {
                        SpellManager.Cast(106830);
                        LogMsg(Thrash + " with Clearcasting", 9);
                        LastSpell = Thrash;
                        return;
                    }
                    if (lifeblood)
                    {
                        SpellManager.Cast("Lifeblood");
                        LogMsg("Lifeblood to regain energy", 3);
                        return;
                    }
                    if (tigersfury)
                    {
                        SpellManager.Cast(TigersFury);
                        LogMsg(TigersFury + " to gain energy", 3);
                        return;
                    }
                    if (burstboss)
                    {
                        if (SpellManager.CanCast(Berserk))
                        {
                            SpellManager.Cast(Berserk);
                        }
                        if (SpellManager.CanCast(Incarnation))
                        {
                            SpellManager.Cast(Incarnation);
                        }
                        if (BerserKing)
                        {
                            SpellManager.Cast(Berserking);
                        }
                        LogMsg("Bursting the Boss", 6);
                        return;
                    }
                    if (burst)
                    {
                        if (SpellManager.CanCast(Berserk))
                        {
                            SpellManager.Cast(Berserk);
                        }
                        if (SpellManager.CanCast(Incarnation))
                        {
                            SpellManager.Cast(Incarnation);
                        }
                        if (BerserKing)
                        {
                            SpellManager.Cast(Berserking);
                        }
                        LogMsg("Bursting the target", 6);
                        return;
                    }
                    if (gotTarget
                        && Me.HasAura("Berserk")
                        && GetSpellCooldown(Incarnation).TotalSeconds <= 0)
                    {
                        if (SpellManager.CanCast(Incarnation))
                        {
                            SpellManager.Cast(Incarnation);
                            LogMsg(Incarnation, 4);
                            return;
                        }
                    }
                    if (symbiosis != "")
                    {
                        SpellManager.Cast(symbiosis);
                        LogMsg("Using symbiosis spell " + symbiosis, 3);
                        return;
                    }
                    if (ferociuosbite25)
                    {
                        SpellManager.Cast(FerociousBite);
                        LogMsg(FerociousBite + " below 25%", 6);
                    }
                    if (ferociuosbite)
                    {
                        SpellManager.Cast(FerociousBite);
                        LogMsg(FerociousBite + " dump CP", 5);
                    }
                    if (rip)
                    {
                        SpellManager.Cast(Rip);
                        LogMsg(Rip, 3);
                    }
                    if (savageRoarcp)
                    {
                        SpellManager.Cast(127538);
                        LogMsg(SavageRoar, 0);
                        return;
                    }
                    if (rake)
                    {
                        SpellManager.Cast(Rake);
                        LogMsg(Rake, 3);
                        return;
                    }
                    if (ravage)
                    {
                        SpellManager.Cast(Ravage);
                        LogMsg(Ravage + " with Incarnation Aura", 3);
                    }
                    /*if (shred)
                    {
                        SpellManager.Cast(Shred);
                        LogMsg(Shred + " on bleeding target", 7);
                    }*/
                    if (swipe)
                    {
                        SpellManager.Cast(Swipe);
                        LogMsg(Swipe + " Aoe", 6);
                    }
                    if (mangle)
                    {
                        SpellManager.Cast(Mangle);
                        LogMsg(Mangle, 3);
                    }
                }
                if (Me.Shapeshift == ShapeshiftForm.Bear
                    && Me.Specialization == WoWSpec.DruidFeral)
                {
                    if (Me.Shapeshift != ShapeshiftForm.Bear)
                    {
                        CastBuff("Bear Form", 2);
                    }
                    if (Me.Shapeshift == ShapeshiftForm.Bear)
                    {
                        if (faerieSwarm)
                        {
                            SpellManager.Cast(FaerieSwarm);
                            LogMsg(FaerieSwarm, 3);
                            return;
                        }
                        if (faerieFire)
                        {
                            SpellManager.Cast(FaerieFire);
                            LogMsg(FaerieFire, 3);
                            return;
                        }
                        if (mightybash && LastSpell != SkullBash)
                        {
                            SpellManager.Cast(MightyBash);
                            LogMsg(MightyBash, 6);
                        }
                        if (skullbash && LastSpell != MightyBash)
                        {
                            SpellManager.Cast(SkullBash);
                            LogMsg(SkullBash, 6);
                        }
                        if (Me.CurrentTarget != null
                            && Me.CurrentTarget.IsAlive
                            && SpellManager.HasSpell(33878)
                            && GetSpellCooldownID(33878).TotalSeconds <= 0
                            && Me.CurrentTarget.IsWithinMeleeRange)
                        {
                            if (SpellManager.CanCast(33878))
                            {
                                SpellManager.Cast(33878);
                                LogMsg("Mangle", 6);
                            }
                            return;
                        }
                        if (Me.CurrentTarget != null
                            && Me.CurrentTarget.IsAlive
                            && (GetSpellCooldownID(77758).TotalSeconds <= 0
                            || MyAuraTimeLeft(77758, Me.CurrentTarget) < 5)
                            && Me.CurrentTarget.IsWithinMeleeRange
                            && LastSpell != Thrash)
                        {
                            //if (SpellManager.CanCast(77758))
                            //{
                            SpellManager.Cast(77758);
                            LogMsg("Thrash", 6);
                            //}
                        }
                        if (Me.CurrentTarget != null
                            && Me.CurrentTarget.IsAlive
                            && SpellManager.HasSpell(779)
                            && GetSpellCooldownID(779).TotalSeconds <= 0
                            && (Me.RagePercent >= 15
                            || Me.HasAura("Clearcasting"))
                            && Me.CurrentTarget.IsWithinMeleeRange)
                        {
                            if (SpellManager.CanCast(779))
                            {
                                SpellManager.Cast(779);
                                LogMsg("Swipe", 6);
                            }
                        }
                        if (Me.CurrentTarget != null
                            && Me.CurrentTarget.IsAlive
                            && SpellManager.HasSpell("Maul")
                            && GetSpellCooldown("Maul").TotalSeconds <= 0
                            && (Me.RagePercent >= 75
                            || Me.HasAura("Clearcasting"))
                            && Me.CurrentTarget.IsWithinMeleeRange)
                        {
                            if (SpellManager.CanCast("Maul"))
                            {
                                SpellManager.Cast("Maul");
                                LogMsg("Maul", 6);
                            }
                        }
                        if (Me.CurrentTarget != null
                            && Me.CurrentTarget.IsAlive
                            && (GetSpellCooldownID(33745).TotalSeconds <= 0
                            || Me.HasAura("Clearcasting"))
                            && Me.CurrentTarget.IsWithinMeleeRange)
                        {
                            //if (SpellManager.CanCast(33745))
                            // {
                            SpellManager.Cast(33745);
                            LogMsg("Lacerate", 6);
                            //}
                        }
                        return;
                    }
                }
                #region guardianrotation
                if (Me.Specialization == WoWSpec.DruidGuardian)
                {
                    if (gotTarget
                        && SpellManager.HasSpell(SavageDefense)
                        && !spellOnCooldown(SavageDefense)
                        && !buffExists(SavageDefense, Me)
                        && Me.RagePercent >= 60
                        && lastCast != SavageDefense)
                    {
                        if (SpellManager.CanCast(SavageDefense))
                        {
                            SpellManager.Cast(SavageDefense);
                            LogMsg("Savage Defense", 8);
                            lastCast = SavageDefense;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(122285)
                        && !spellOnCooldown(122285))
                    {
                        SpellManager.Cast(122285);
                        LogMsg("Bone Shield", 3);
                    }
                    if (SpellManager.HasSpell(22812)
                         && !spellOnCooldown(22812)
                         && Me.HealthPercent <= FeralKittySettings.AllPrefs.Barskin)
                    {
                        SpellManager.Cast(22812);
                    }
                    if (SpellManager.HasSpell(SurvivalInstincts)
                        && GetSpellCooldown(SurvivalInstincts).TotalSeconds <= 0
                        && Me.HealthPercent <= FeralKittySettings.AllPrefs.SurvivalInstincts)
                    {
                        CastSpell(SurvivalInstincts, 2);
                    }
                    if (SpellManager.HasSpell(FrenziedRegeneration)
                        && GetSpellCooldown(FrenziedRegeneration).TotalSeconds <= 0
                        && Me.HealthPercent <= FeralKittySettings.AllPrefs.FrenziedRegeneration
                        && Me.RagePercent >= 60)
                    {
                        CastSpell(FrenziedRegeneration, 2);
                    }
                    if (SpellManager.HasSpell(MightOfUrsoc)
                        && GetSpellCooldown(MightOfUrsoc).TotalSeconds <= 0
                        && Me.HealthPercent <= FeralKittySettings.AllPrefs.MightOfUrsoc)
                    {
                        CastSpell(MightOfUrsoc, 2);
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(Enrage)
                        && !spellOnCooldown(Enrage)
                        && Me.RagePercent <= 10)
                    {
                        if (SpellManager.CanCast(Enrage))
                        {
                            SpellManager.Cast(Enrage);
                            LogMsg("Enrage", 5);
                            lastCast = Enrage;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(NaturesVigilBear)
                        && !spellOnCooldown(NaturesVigilBear)
                        && FeralKittySettings.AllPrefs.NaturesVigil == 1
                        || (FeralKittySettings.AllPrefs.NaturesVigil == 2
                        && IsBoss))
                    {
                        if (SpellManager.CanCast(NaturesVigilBear))
                        {
                            SpellManager.Cast(NaturesVigilBear);
                            LogMsg("Natures Vigil Bear", 2);
                            lastCast = NaturesVigilBear;
                            return;
                        }
                    }

                    if (mightybashbear && LastSpell != SkullBash)
                    {
                        SpellManager.Cast(MightyBashBear);
                        LogMsg("Mighty Bash Bear", 5);
                        LastSpell = MightyBash;
                    }
                    if (skullbashbear && LastSpell != MightyBash)
                    {
                        SpellManager.Cast(SkullBashBear);
                        LogMsg("Skull Bash Bear", 5);
                        LastSpell = SkullBash;
                    }
                    if(gotTarget
                        && SpellManager.HasSpell(FaerieSwarmBear)
                        && !debuffExists(FaerieSwarmBear, Me.CurrentTarget)
                        && !spellOnCooldown(FaerieSwarmBear)
                        && lastCast != FaerieSwarmBear)
                    {
                        if (SpellManager.CanCast(FaerieSwarmBear))
                        {
                            SpellManager.Cast(FaerieSwarmBear);
                            LogMsg("FaerieSwarm Bear", 6);
                            lastCast = FaerieSwarmBear;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(FaerieFireBear)
                        && !debuffExists(FaerieFireBear, Me.CurrentTarget)
                        && !spellOnCooldown(FaerieFireBear)
                        && lastCast != FaerieSwarmBear)
                    {
                        if (SpellManager.CanCast(FaerieFireBear))
                        {
                            SpellManager.Cast(FaerieFireBear);
                            LogMsg("Faerie Fire Bear", 6);
                            lastCast = FaerieFireBear;
                            return;
                        }
                    } 
                    if (gotTarget
                        && SpellManager.HasSpell(LifebloodBear)
                        && !spellOnCooldown(LifebloodBear)
                        && FeralKittySettings.AllPrefs.LifebloodBear == 1
                        || (FeralKittySettings.AllPrefs.LifebloodBear == 2
                        && IsBoss))
                    {
                        if (SpellManager.CanCast(LifebloodBear))
                        {
                            SpellManager.Cast(LifebloodBear);
                            LogMsg("Lifeblood Bear", 8);
                            lastCast = LifebloodBear;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(ThrashBear)
                        && !spellOnCooldown(ThrashBear)
                        && (!debuffExists(ThrashBear, Me.CurrentTarget)
                        || debuffTimeLeft(ThrashBear, Me.CurrentTarget) < 5)
                        && lastCast != ThrashBear)
                    {
                        if (SpellManager.CanCast(ThrashBear))
                        {
                            SpellManager.Cast(ThrashBear);
                            LogMsg("Thrash Bear", 2);
                            lastCast = ThrashBear;
                            return;
                        }
                    }
                    if (burstbossbear)
                    {
                        if (SpellManager.CanCast(BerserkBear))
                        {
                            SpellManager.Cast(Berserk);
                        }
                        if (SpellManager.CanCast(IncarnationBear))
                        {
                            SpellManager.Cast(IncarnationBear);
                        }
                        if (BerserKing)
                        {
                            SpellManager.Cast(BerserkingBear);
                        }
                        LogMsg("Bursting the Boss", 6);
                        return;
                    }
                    if (burstbear)
                    {
                        if (SpellManager.CanCast(BerserkBear))
                        {
                            SpellManager.Cast(BerserkBear);
                        }
                        if (SpellManager.CanCast(IncarnationBear))
                        {
                            SpellManager.Cast(IncarnationBear);
                        }
                        if (BerserKing)
                        {
                            SpellManager.Cast(BerserkingBear);
                        }
                        LogMsg("Bursting the target", 6);
                        return;
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(IncarnationBear)
                        && buffExists(BerserkBear, Me)
                        && !spellOnCooldown(IncarnationBear))
                    {
                        if (SpellManager.CanCast(IncarnationBear))
                        {
                            SpellManager.Cast(IncarnationBear);
                            LogMsg("Incarnation Bear", 9);
                            lastCast = IncarnationBear;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(MangleBear)
                        && !spellOnCooldown(MangleBear))
                    {
                        if (SpellManager.CanCast(MangleBear))
                        {
                            SpellManager.Cast(MangleBear);
                            LogMsg("Mangle Bear", 1);
                            lastCast = MangleBear;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(SwipeBear)
                        && !spellOnCooldown(SwipeBear)
                        && addCount >= 2)
                    {
                        if (SpellManager.CanCast(SwipeBear))
                        {
                            SpellManager.Cast(SwipeBear);
                            LogMsg("Swipe Bear", 7);
                            lastCast = SwipeBear;
                            return;
                        }
                    }
                    if (gotTarget
                        && SpellManager.HasSpell(MaulBear)
                        && buffExists(ToothAndClaws, Me)
                        && !spellOnCooldown(MaulBear)
                        && Me.RagePercent >= 30)
                    {
                        if (SpellManager.CanCast(MaulBear))
                        {
                            SpellManager.Cast(MaulBear);
                            LogMsg("Maul Bear", 3);
                            lastCast = MaulBear;
                            return;
                        }
                    }
                }
                if (gotTarget
                    && SpellManager.HasSpell(LacerateBear)
                    && !spellOnCooldown(LacerateBear))
                {
                    if (SpellManager.CanCast(LacerateBear))
                    {
                        SpellManager.Cast(LacerateBear);
                        LogMsg("Lacerate Bear", 4);
                        lastCast = LacerateBear;
                        return;
                    }
                }
                #endregion guardianrotation
            }
        }
        #endregion Rotations

        #region Spells


        private void AutoAttack()
        {
            if (!Me.IsAutoAttacking)
            {
                Lua.DoString("StartAttack()");
            }

        }
        #endregion
    }
}
